﻿using System;
using UnityEngine;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MacGruber;

namespace SPQR
{
    public class SPQRDynamicPosition : MVRScript
    {

        private EventTrigger myEventTrigger;

        JSONStorableFloat varValueSliderMin;
        JSONStorableFloat varValueSliderMax;
        JSONStorableFloat varValueSlider;
        JSONStorableString varValue;
        JSONStorableString varValue2;
        JSONStorableStringChooser varOperation;
        int titles = 0;

        UIDynamicTextField dtext2;

        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);


            CreateTitle("DYNAMIC Position", 50, false);
            CreateTitle("AETERNUM TOOLS", 30, true);

            InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);


            JSONStorableString jstring = new JSONStorableString("instructions2", "\n This plugin is meant to be called from triggers. Here you can just set min, max and default values for your field. It updates the numerical value held by this text atom. \n\n For operations Pos Set and Rot Set you can set 3 coordinates separated by comma like 0,0,0. For the other operations you can set a single value. ");
            UIDynamicTextField dtext = CreateTextField(jstring);
            dtext.UItext.supportRichText = true;
            dtext.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext.height = 350f;



            JSONStorableString jstring2 = new JSONStorableString("instructions1", GetNowText());
            dtext2 = CreateTextField(jstring2, true);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 350f;


            Utils.SetupSpacer(this, 70, false);
            Utils.SetupSpacer(this, 70, true);


            myEventTrigger = new EventTrigger(this, "TriggerOnUpdate");
            Utils.SetupButton(this, "Trigger On Update", myEventTrigger.OpenPanel, false);

            Utils.SetupButton(this, "Test Trigger", TestTrigger, true);
            //Utils.SetupAction(this, "TriggerOnUpdate", Trigger);
            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            SimpleTriggerHandler.LoadAssets();


            Utils.SetupSpacer(this, 50, false);
            Utils.SetupSpacer(this, 50, true);

            // varValueSliderMin = new JSONStorableFloat("ValSliderMin", 0f, UpdateVarValueSlider, -360f, 360f, false);
            // RegisterFloat(varValueSliderMin);
            // UIDynamicSlider dslider2 = CreateSlider(varValueSliderMin);

            // varValueSliderMax = new JSONStorableFloat("ValSliderMax", 360f, UpdateVarValueSlider, -360f, 360f, false);
            // RegisterFloat(varValueSliderMax);
            // UIDynamicSlider dslider3 = CreateSlider(varValueSliderMax);

            // varValueSlider = new JSONStorableFloat("ValSlider", 0f, UpdateVarValueSlider, 0f, 100f, false);
            // RegisterFloat(varValueSlider);
            // UIDynamicSlider dslider = CreateSlider(varValueSlider);


            varValue = new JSONStorableString("Value", "", UpdateVarValue);
            RegisterString(varValue);
            UIDynamicLabelInput myStringInput = Utils.SetupTextInput(this, "Value", varValue, false);

            varValue2 = new JSONStorableString("Parameter", "", UpdateVarValue2);
            RegisterString(varValue2);
            UIDynamicLabelInput myStringInput2 = Utils.SetupTextInput(this, "Parameter", varValue2, false);

            List<string> choices = new List<string>();
            choices.Add("None");
            choices.Add("PosX Set");
            choices.Add("PosY Set");
            choices.Add("PosZ Set");
            choices.Add("PosX Add");
            choices.Add("PosY Add");
            choices.Add("PosZ Add");

            choices.Add("RotX Set");
            choices.Add("RotY Set");
            choices.Add("RotZ Set");
            choices.Add("RotX Add");
            choices.Add("RotY Add");
            choices.Add("RotZ Add");

            choices.Add("Pos Set");
            choices.Add("Rot Set");

            choices.Add("MoveToParamAtom");
            choices.Add("MoveRotToAtom");
            //choices.Add("RotateTowardsParamAtom");
            choices.Add("CopyPosition");
            choices.Add("CopyRotation");

            varOperation = new JSONStorableStringChooser("OperationType", choices, "None", "Operation", OperationUpdate);
            RegisterStringChooser(varOperation);
            UIDynamicPopup udp = CreatePopup(varOperation, true);
            udp.labelWidth = 300f;

            Utils.SetupSpacer(this, 1350, false);
            Utils.SetupSpacer(this, 1350, true);

            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;
            UIUpdate();
        }
        private void OnAtomRename(string oldid, string newid)
        {
            myEventTrigger.SyncAtomNames();
        }
        private void UIUpdate()
        {
        }


        void Start()
        {
            try
            {
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Update()
        {
            try
            {
                //    myEventTrigger.Update();
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private void TestTrigger()
        {
            Trigger();

        }
        private void Trigger()
        {
            myEventTrigger.Trigger();
        }

        void FixedUpdate()
        {
            try
            {
                // put code in here
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnDestroy()
        {
            SuperController.singleton.onAtomUIDRenameHandlers -= OnAtomRename;
            myEventTrigger.Remove();
            Utils.OnDestroyUI();
            CancelInvoke();
        }
        void UpdateConstant5()
        {
            if (IsDisabled()) return;
            dtext2.text = GetNowText();
        }

        bool IsDisabled()
        {
            if (!enabledJSON.val)
            {
                return true;
            }
            return false;
        }



        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            if (includePhysical || forceStore)
            {
                needsStore = true;
                jc[myEventTrigger.Name] = myEventTrigger.GetJSON(base.subScenePrefix);
            }
            return jc;
        }

        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);

            if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
            {
                myEventTrigger.RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
            }
        }



        //////////////////////////////////////////////

        string GetNowText()
        {
            FreeControllerV3 atomController = containingAtom.GetStorableByID("control") as FreeControllerV3;

            var rotationstring =
                    System.Math.Round(atomController.transform.rotation.eulerAngles.x, 2) + ", " +
                    System.Math.Round(atomController.transform.rotation.eulerAngles.y, 2) + ", " +
                    System.Math.Round(atomController.transform.rotation.eulerAngles.z, 2);

            return "\n Now pos: (" + System.Math.Round(atomController.transform.position.x, 2) + ", " + System.Math.Round(atomController.transform.position.y, 2) + ", " + System.Math.Round(atomController.transform.position.z, 2) + ") \n Now rot: (" + rotationstring + ")";
        }

        void UpdateVarValue(string name) { }
        void UpdateVarValue2(string name) { }
        void UpdateVarValueSlider(float val)
        {
            var diff = varValueSliderMax.val - varValueSliderMin.val;
            varValue.val = (varValueSliderMin.val + val * diff / 100).ToString();
        }

        protected void OperationUpdate(string s)
        {
            try
            {
                FreeControllerV3 atomController = containingAtom.GetStorableByID("control") as FreeControllerV3;
                Vector3 atomDestination = new Vector3(atomController.transform.position.x, atomController.transform.position.y, atomController.transform.position.z);
                Vector3 atomDestinationRotSelf = new Vector3(0f, 0f, 0f);
                Vector3 atomDestinationRot = new Vector3(atomController.transform.rotation.eulerAngles.x, atomController.transform.rotation.eulerAngles.y, atomController.transform.rotation.eulerAngles.z);

                float newValue;
                if (varOperation.val == "None") return;
                bool isSelf = varValue2.val == "self";
                switch (varOperation.val)
                {
                    case "Pos Set":
                        string[] splitArray = varValue.val.Split(',');
                        if (splitArray.Count() != 3) return;
                        atomDestination.x = ToFloat(splitArray[0]);
                        atomDestination.y = ToFloat(splitArray[1]);
                        atomDestination.z = ToFloat(splitArray[2]);
                        atomController.transform.position = atomDestination;
                        break;
                    case "Rot Set":
                        string[] splitArray2 = varValue.val.Split(',');
                        if (splitArray2.Count() != 3) return;
                        atomDestinationRot.x = ToFloat(splitArray2[0]);
                        atomDestinationRot.y = ToFloat(splitArray2[1]);
                        atomDestinationRot.z = ToFloat(splitArray2[2]);
                        atomController.transform.rotation = Quaternion.Euler(atomDestinationRot);
                        break;
                    case "PosX Set":
                        newValue = ToFloat(varValue.val);
                        atomDestination.x = newValue;
                        atomController.transform.position = atomDestination;
                        break;
                    case "PosY Set":
                        newValue = ToFloat(varValue.val);
                        atomDestination.y = newValue;
                        atomController.transform.position = atomDestination;
                        break;
                    case "PosZ Set":
                        newValue = ToFloat(varValue.val);
                        atomDestination.z = newValue;
                        atomController.transform.position = atomDestination;
                        break;
                    case "PosX Add":
                        newValue = ToFloat(varValue.val);
                        if(isSelf){
                            atomDestination += newValue * atomController.transform.right;
                        } else {
                            atomDestination += newValue * Vector3.right;
                        }
                        atomController.transform.position = atomDestination;
                        break;
                    case "PosY Add":
                        newValue = ToFloat(varValue.val);
                         if(isSelf){
                            atomDestination += newValue * atomController.transform.up;
                        } else {
                            atomDestination += newValue * Vector3.up;
                        }
                        atomController.transform.position = atomDestination;
                        break;
                    case "PosZ Add":
                        newValue = ToFloat(varValue.val);
                         if(isSelf){
                            atomDestination += newValue * atomController.transform.forward;
                        } else {
                            atomDestination += newValue * Vector3.forward;
                        }
                        atomController.transform.position = atomDestination;
                        break;

                    case "RotX Add":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRotSelf.x += newValue;
                        atomController.transform.Rotate(atomDestinationRotSelf, Space.Self);
                        break;
                    case "RotY Add":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRotSelf.y += newValue;
                        atomController.transform.Rotate(atomDestinationRotSelf, Space.Self);
                        break;
                    case "RotZ Add":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRotSelf.z += newValue;
                        atomController.transform.Rotate(atomDestinationRotSelf, Space.Self);
                        break;

                    case "RotX Set":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRot.x = newValue;
                        atomController.transform.rotation = Quaternion.Euler(atomDestinationRot);
                        break;
                    case "RotY Set":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRot.y = newValue;
                        atomController.transform.rotation = Quaternion.Euler(atomDestinationRot);
                        break;
                    case "RotZ Set":
                        newValue = ToFloat(varValue.val);
                        atomDestinationRot.z = newValue;
                        atomController.transform.rotation = Quaternion.Euler(atomDestinationRot);
                        break;

                    case "CopyPosition":
                        varValue.val = System.Math.Round(atomController.transform.position.x, 2) + ", " + System.Math.Round(atomController.transform.position.y, 2) + ", " + System.Math.Round(atomController.transform.position.z, 2);
                        break;
                    case "CopyRotation":
                        var rotationstring =
                                System.Math.Round(atomController.transform.rotation.eulerAngles.x, 2) + ", " +
                                System.Math.Round(atomController.transform.rotation.eulerAngles.y, 2) + ", " +
                                System.Math.Round(atomController.transform.rotation.eulerAngles.z, 2);
                        varValue.val = rotationstring;
                        break;

                    case "MoveToParamAtom":
                        if(varValue2.val.Length >=0){
                            var destination = SPQRUtils.getAtomById(varValue2.val);
                            if(destination!=null){
                                MoveToAtom(destination);
                            }
                        }
                        break;

                    case "MoveRotToAtom":
                        if (varValue2.val.Length >= 0)
                        {
                            var destination = SPQRUtils.getAtomById(varValue2.val);
                            if (destination != null)
                            {
                                MoveRotToAtom(destination);
                            }
                        }
                        break;

                    case "RotateTowardsParamAtom":
                        if (varValue2.val.Length >= 0)
                        {
                            var destination = SPQRUtils.getAtomById(varValue2.val);
                            if (destination != null)
                            {
                                RotateTowardsAtom(destination);
                            }
                        }
                        break;

                } 


               

                Trigger();

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
            //varValue.val = "";
            varValue2.val = "";
            varOperation.val = "None";

        }

        void MoveToAtom(Atom D){
            Vector3 offset = Vector3.zero;
            string[] splitArray = varValue.val.Split(',');
            if (splitArray.Count() == 3){
                offset.x = ToFloat(splitArray[0]);
                offset.y = ToFloat(splitArray[1]);
                offset.z = ToFloat(splitArray[2]);
            }

            var destination = D.mainController.transform.position + 
                            offset.x * D.mainController.transform.right +
                            offset.y * D.mainController.transform.up +
                            offset.z * D.mainController.transform.forward;

            containingAtom.mainController.transform.position = destination;
        }

        void MoveRotToAtom(Atom D)
        {
            containingAtom.mainController.transform.position = D.mainController.transform.position;
            containingAtom.mainController.transform.localEulerAngles = D.mainController.transform.localEulerAngles;
        }

        void RotateTowardsAtom(Atom D)
        {
            Vector3 direction = D.mainController.transform.position - containingAtom.mainController.transform.position;
            containingAtom.transform.rotation = Quaternion.LookRotation(direction);
        }

        public static int ToInt(string s)
        {
            if (s == "" || s == null) s = "0";
            return Int32.Parse(s);
        }
        public static float ToFloat(string s)
        {
            if (s == "" || s == null) s = "0";
            return float.Parse(s);
        }


        public int GetText()
        {
            JSONStorable f = containingAtom.GetStorableByID("Text");
            JSONStorableString fs = f.GetStringJSONParam("text");
            return ToInt(fs.val);
        }

        void SetAtomText(string t)
        {
            JSONStorable f = containingAtom.GetStorableByID("Text");
            JSONStorableString fs = f.GetStringJSONParam("text");
            fs.val = t;
        }


        private void CreateTitle(string text, int fontsize, bool right, int spacing)
        {
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right)
        {
            JSONStorableString title1 = new JSONStorableString("title" + (++titles), "\n<size=" + fontsize + "><b>" + text + "</b></size>");
            UIDynamicTextField title1text = CreateTextField(title1, right);
            title1text.UItext.supportRichText = true;
            title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
            title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            title1text.height = 100f;
            title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

    }
}