﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR 
{
    public class BiggerAtoms : MVRScript
    {
        string pluginName = "BiggerAtoms";
        bool sceneLoaded = false;

        JSONStorableFloat scaleX;
        JSONStorableFloat scaleY;
        JSONStorableFloat scaleZ;

        Transform referenceTransform;
        public override void Init()
        {
            if (NotAllowed()) return;
            scaleX = new JSONStorableFloat("Scale X", 1f, UpdateScale, 0.001f, 100f, false);
            RegisterFloat(scaleX);
            CreateSlider(scaleX);
            scaleY = new JSONStorableFloat("Scale Y", 1f, UpdateScale, 0.001f, 100f, false);
            RegisterFloat(scaleY);
            CreateSlider(scaleY);
            scaleZ = new JSONStorableFloat("Scale Z", 1f, UpdateScale, 0.001f, 100f, false);
            RegisterFloat(scaleZ);
            CreateSlider(scaleZ);

            referenceTransform = containingAtom.reParentObject;

        }


        void Start()
        {
            UpdateScale();
            //
            //for (int i = 0; i < containingAtom.gameObject.transform.childCount; i++)
            //{
            //    Transform childTransform = containingAtom.gameObject.transform.GetChild(i);
            //    SuperController.LogMessage(i.ToString() + ": " + childTransform.name);
            //}
        }

        void Update()
        {

        }


        void FixedUpdate()
        {

        }

        bool NotAllowed()
        {
            if (containingAtom.type == "")
            {
                SuperController.LogError(pluginName + " needs to be on an atom.");
                return true;
            }
            if (containingAtom.type == "Person")
            {
                SuperController.LogError(pluginName + " doesn't work with Person atoms because headaches to the modder.");
                return true;
            }
            return false;
        }

        void UpdateScale(float t = 0f)
        {
            var positionBefore = containingAtom.mainController.transform.position;
            referenceTransform.localScale = new Vector3(scaleX.val, scaleY.val, scaleZ.val);
            containingAtom.mainController.transform.position = positionBefore;
        }


    }
}