﻿using System;
using UnityEngine;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;

namespace SPQR
{
    public class SPQRDesktopPoseHelper : MVRScript
    {
        // JSONStorableBool jbool;
        JSONStorableBool logo;
        JSONStorableBool logor;
        JSONStorableBool jstring;
        JSONStorableBool jstring2;

        FreeControllerV3.PositionState initialPositionState;
        FreeControllerV3.RotationState initialRotationState;
        bool initialPositionStateModified;
        bool initialPhysics;
        bool initialCollision;
        bool initialGravity;

		float moveDelta = 0.0075f;
		float rotateDelta = 2f;

        bool isPersonSubcontrol = false;

        public override void InitUI()
        {
            base.InitUI();

            if (UITransform == null) return;

            RectTransform leftRect = leftUIContent.GetComponent<RectTransform>();
            RectTransform rightRect = rightUIContent.GetComponent<RectTransform>();

            leftRect.anchorMax = new Vector2(0.66f, 1f);
            rightRect.anchorMin = new Vector2(0.66f, 1f);

        }


        public override void Init()
        {
            try
            {

                JSONStorableString logo = new JSONStorableString("logostring", "\n<size=40><b>Desktop Pose Helper</b></size>");
                UIDynamicTextField logotext = CreateTextField(logo);
                logotext.UItext.supportRichText = true;
                logotext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logotext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                logotext.height = 100f;
                logotext.UItext.alignment = TextAnchor.UpperLeft;


                JSONStorableString logor = new JSONStorableString("logospace", "\n<size=30><b>v1</b></size>");
                UIDynamicTextField logortext = CreateTextField(logor, true);
                logortext.UItext.supportRichText = true;
                logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logortext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                logortext.height = 100f;
                logortext.UItext.alignment = TextAnchor.UpperRight;


                JSONStorableString jstring = new JSONStorableString("instructions1", "\nAdd the plugin as a Session plugin or Scene plugin. ");
                UIDynamicTextField dtext = CreateTextField(jstring, true);
                dtext.UItext.supportRichText = true;
                dtext.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
                dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext.height = 250f;

                
                JSONStorableString jstring2 = new JSONStorableString("instructions2", "\n <b>CTRL-WASDQE</b> move selected controller relative to the camera \n <b>CTRL-SHIFT-WASDQE</b> rotate selected controller relative to the camera \n <b>SHIFT-1, SHIFT-2,..,SHIFT-7</b> select main controllers:head, left hand,right hand etc.  \n <b>CTRL-R</b> Set position & rotation for the selected controller to ON \n <b>CTRL-T</b> Set position & rotation for the selected controller to COMPLY  \n <b>CTRL-Y</b> Set position & rotation for the selected controller to OFF  \n <b>CTRL-N</b> while holding it it will temporarily set the selected controller to OFF in order for it to autmatically take a more natural position.");
                UIDynamicTextField dtext2 = CreateTextField(jstring2);
                dtext2.UItext.supportRichText = true;
                dtext2.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
                dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext2.height = 550f;
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Start()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        void Update()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught x: " + e);
            }
        }
        void TargetStateOn(){
            FreeControllerV3 atomController = GetTargetController();
            atomController.currentPositionState = FreeControllerV3.PositionState.On;
            atomController.currentRotationState = FreeControllerV3.RotationState.On;
        }
        void TargetStateOff(){
            FreeControllerV3 atomController = GetTargetController();
            atomController.currentPositionState = FreeControllerV3.PositionState.Off;
            atomController.currentRotationState = FreeControllerV3.RotationState.Off;
        }
         void TargetStateComply(){
            FreeControllerV3 atomController = GetTargetController();
            atomController.currentPositionState = FreeControllerV3.PositionState.Comply;
            atomController.currentRotationState = FreeControllerV3.RotationState.Comply;
        }

        
        void FixedUpdate()
        {
            try
            {   
                if(GetTarget() == null) return;

                if (Input.GetKey(KeyCode.LeftShift)){    
                    if (Input.GetKey(KeyCode.Alpha1)) SelectPersonController("headControl");
                    if (Input.GetKey(KeyCode.Alpha2)) SelectPersonController("lHandControl");
                    if (Input.GetKey(KeyCode.Alpha3)) SelectPersonController("rHandControl");
                    if (Input.GetKey(KeyCode.Alpha4)) SelectPersonController("lFootControl");
                    if (Input.GetKey(KeyCode.Alpha5)) SelectPersonController("rFootControl");
                    if (Input.GetKey(KeyCode.Alpha6)) SelectPersonController("chestControl");
                    if (Input.GetKey(KeyCode.Alpha7)) SelectPersonController("hipControl");
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Q)) RotateForward();
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.E)) RotateBack();
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.D)) RotateLeft();
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.A)) RotateRight();
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.W)) RotateUp();
                     if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.S)) RotateDown();
                } else {

                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.R)) TargetStateOn();
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.T)) TargetStateComply();
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Y)) TargetStateOff();

                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.W))
                    {
                        MoveSelectedAtomDesktop(false);
                    }
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.S))
                    {
                        MoveSelectedAtomDesktop(true);
                        
                    }
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.A))
                    {
                    MoveSelectedAtomDesktopSide(true);
                        
                    }
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.D))
                    {
                        MoveSelectedAtomDesktopSide(false);
                    }
                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.E))
                    {
                        MoveSelectedAtomDesktopUp(true);
                    }

                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Q))
                    {
                        MoveSelectedAtomDesktopUp(false);
                    }

                    if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.N))
                    {
                        MoveNormalize();
                    }
                }
				
				


               

                if (initialPositionStateModified)
                {
                    ResetPositionState();
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught x: " + e);
            }

        }
        void OnDestroy()
        {
        }


        //

        void SelectPersonController(string c){
            var person = GetTarget();
            if(person == null) return;

            FreeControllerV3 contr = person.GetStorableByID(c) as FreeControllerV3;
            SuperController.singleton.SelectController(contr,false,false,false,true);
        }

        Atom GetTarget()
        {
            var atom = SuperController.singleton.GetSelectedAtom();
            if (containingAtom.type != "SessionPluginManager" && containingAtom.type != "CoreControl")
            {
                atom = containingAtom;
            }
            if(atom == null) return null;
            if(atom.type != "Person") return null; 
            return atom;
        }

         FreeControllerV3 GetTargetController()
        {
            isPersonSubcontrol = false;
            if (containingAtom.type != "SessionPluginManager" && containingAtom.type != "CoreControl")
            {
                var atom = containingAtom;
                FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
                return atomController;
            } 
            Atom target = GetTarget();
            if (target.type == "Person"){
                isPersonSubcontrol = true;
            }
            FreeControllerV3 selectedController = SuperController.singleton.GetSelectedController();
            return selectedController;
        }
        void ResetPositionState()
        {
            initialPositionStateModified = false;
            FreeControllerV3 atomController = GetTargetController();
            atomController.currentPositionState = initialPositionState;
            atomController.currentRotationState = initialRotationState;
            //atomController.physicsEnabled = initialPhysics;
            atomController.collisionEnabled = initialCollision;
            atomController.useGravityOnRBWhenOff = initialGravity;
        }
        void SetPositionState(FreeControllerV3 atomController){
            SetPositionState(atomController, false);
        }


        void SetPositionState(FreeControllerV3 atomController, bool off)
        {
            if (!initialPositionStateModified)
            {
                initialPositionStateModified = true;
                //initialPhysics = atomController.physicsEnabled;
                initialCollision = atomController.collisionEnabled;
                initialGravity = atomController.useGravityOnRBWhenOff;
                initialPositionState = atomController.currentPositionState;
                initialRotationState = atomController.currentRotationState;
            }
            if(off){
                
            } else {
                atomController.currentPositionState = FreeControllerV3.PositionState.Hold;
                atomController.currentRotationState = FreeControllerV3.RotationState.Hold;
            }
            //atomController.physicsEnabled = false;
            atomController.collisionEnabled = false;
            atomController.useGravityOnRBWhenOff = false;
        }




		void Resetobject(FreeControllerV3 atomController){
			Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;	
			atomController.transform.localRotation = Quaternion.identity;
			atomController.transform.LookAt(cameraPosition);
			atomController.transform.Rotate(new Vector3(-atomController.transform.localEulerAngles.x,0f,-atomController.transform.localEulerAngles.z),Space.Self);

		}


        void MoveNormalize(){
            FreeControllerV3 atomController = GetTargetController();
            //SetPositionState(atomController, true);            
            if(atomController.currentPositionState == FreeControllerV3.PositionState.Off){
                ResetPositionState();
            } else {
                atomController.currentPositionState = FreeControllerV3.PositionState.Off;
                atomController.currentRotationState = FreeControllerV3.RotationState.Off;
            }
        }

		
		void MoveLeft(){
			FreeControllerV3 atomController = GetTargetController();
            if(!isPersonSubcontrol){ 
                Resetobject(atomController);
                atomController.transform.Rotate(new Vector3(0f,90f,0f),Space.Self);
                Vector3 atomDestination = new Vector3(0f, 0f,moveDelta);
			    atomController.transform.Translate(atomDestination);
            } else {
                Vector3 atomDestination = new Vector3(moveDelta, 0f, 0f);
			    atomController.transform.Translate(atomDestination);
            }
			
		}
		void MoveRight(){
			FreeControllerV3 atomController = GetTargetController();
            if(!isPersonSubcontrol){ 
                Resetobject(atomController);
                atomController.transform.Rotate(new Vector3(0f,270f,0f),Space.Self);
                Vector3 atomDestination = new Vector3(0f, 0f, moveDelta);
			    atomController.transform.Translate(atomDestination);
            } else {
                Vector3 atomDestination = new Vector3(-moveDelta, 0f, 0f);
			    atomController.transform.Translate(atomDestination);
            }
			
		}
			
		void PositionReset(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Vector3 atomDestination = new Vector3(atomController.transform.position.x, 0f, atomController.transform.position.z);
			atomController.transform.position = atomDestination;
		}
		void RotateReset(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.localRotation = Quaternion.identity;
		}

		void RotateUp(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(-rotateDelta,0f,0f),Space.Self);
		}
		void RotateDown(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(rotateDelta,0f,0f),Space.Self);
		}
        void RotateLeft(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(0f,-rotateDelta,0f),Space.Self);
		}
		void RotateRight(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(0f,rotateDelta,0f),Space.Self);
		}
		void RotateForward(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(0f,0f,-rotateDelta),Space.Self);
		}
		void RotateBack(){
			FreeControllerV3 atomController = GetTargetController();
			atomController.transform.Rotate(new Vector3(0f,0f,rotateDelta),Space.Self);
		}


        public Vector3 RotatePointAroundPivot(Vector3 point, Vector3 pivot, Vector3 angles) {
            return Quaternion.Euler(angles) * (point - pivot) + pivot;
        }

        void MoveSelectedAtomDesktopSide(bool pull)
        {
            Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;
            FreeControllerV3 atomController = GetTargetController();
            Vector3 atomPosition = atomController.transform.position;
            cameraPosition.y = atomPosition.y;

            Vector3 pivotAngles = new Vector3(0f,90f,0f);

            Vector3 atomDestination = RotatePointAroundPivot(cameraPosition, atomPosition, pivotAngles);

            if (atomPosition == atomDestination) return;
            float distance = Vector3.Distance(atomPosition, atomDestination);
            if (distance < 0.0f && pull) return;

            float delta = pull ? moveDelta : -moveDelta;
            Vector3 newPosition = Vector3.MoveTowards(atomPosition, atomDestination, delta);
            SetPositionState(atomController);
            atomController.transform.position = newPosition;
        }


         void MoveSelectedAtomDesktopUp(bool pull)
        {
            Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;

            FreeControllerV3 atomController = GetTargetController();
            Vector3 atomPosition = atomController.transform.position;

            Vector3 pivotAngles = new Vector3(90f,0f,0f);

            Vector3 atomDestination = RotatePointAroundPivot(cameraPosition, atomPosition, pivotAngles);
            //atomDestination = Vector3.RotateTowards(atomDestination,atomPosition, 360f, 0f);

             float delta = pull ? moveDelta : -moveDelta;
            atomDestination = new Vector3(0f,delta,0f);

            if (atomPosition == atomDestination) return;
            float distance = Vector3.Distance(atomPosition, atomDestination);
            if (distance < 0.0f && pull) return;

            Vector3 newPosition = Vector3.MoveTowards(atomPosition, atomDestination, delta);
            SetPositionState(atomController);
            atomController.transform.position = newPosition;
        }


        void MoveSelectedAtomDesktop(bool pull)
        {
            Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;
            FreeControllerV3 atomController = GetTargetController();
            Vector3 atomPosition = atomController.transform.position;
            Vector3 atomDestination = new Vector3(cameraPosition.x, atomPosition.y, cameraPosition.z);

            if (atomPosition == atomDestination) return;
            float distance = Vector3.Distance(atomPosition, atomDestination);
            if (distance < 0.0f && pull) return;

            float delta = pull ? moveDelta : -moveDelta;
            Vector3 newPosition = Vector3.MoveTowards(atomPosition, atomDestination, delta);
            SetPositionState(atomController);
            atomController.transform.position = newPosition;
        }


    }
}