﻿using System;
using UnityEngine;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MVR.FileManagementSecure;
using MacGruber;
using Random = UnityEngine.Random;

namespace SPQR
{
    public class Factory : MVRScript {

		Dictionary<string, float>  morphsList1;
		Dictionary<string, float>  morphsList2;
		Dictionary<string, int>  morphsIds;
		

        Dictionary<string, float>  undo;
		
		private const int countSliders = 10;
		JSONStorableFloat jfloat;
		JSONStorableString[] sliderName;
		JSONStorableFloat[] sliderValue;        
		JSONStorableFloat[] sliderStart;
		JSONStorableFloat[] sliderEnd;
		UIDynamicSlider[] dsliders;
		UIDynamicSlider[] dsliders2;
		UIDynamicSlider dslider;
		JSONStorableString jstring3;
		
		int titles = 0;



        List<string> actions = new List<string>(new string[] { "None", "Reset", "New Random", "Alter", "Re-Alter", "Alter+","Re-Alter+", "Undo" });

        List<string> modes = new List<string>(new string[] { "Full Body", "Head" });
        JSONStorableStringChooser varOperation;
        JSONStorableStringChooser varMode;
        JSONStorableFloat morphchangechance;
        JSONStorableFloat morphchangeamountmin;
        JSONStorableFloat morphchangeamountmax;

		public override void Init() {
			
		    if (containingAtom.type != "Person"){
				 CreateTitle("Must be added to a Person",28,false);
				return;
			}
			
			
			
			sliderName = new JSONStorableString[countSliders];
			sliderValue = new JSONStorableFloat[countSliders];
			sliderStart = new JSONStorableFloat[countSliders];
			sliderEnd = new JSONStorableFloat[countSliders];
			dsliders = new UIDynamicSlider[countSliders];
			dsliders2 = new UIDynamicSlider[countSliders];
			morphsList1 = new Dictionary<string, float>(){};
			morphsList2 = new Dictionary<string, float>(){};
			morphsIds = new Dictionary<string, int>(){};

			
			Utils.OnInitUI(CreateUIElement);
			
            CreateTitle("Factory v2",50,false);
			Utils.SetupSpacer(this, 100, true);

						
			JSONStorableString jstring = new JSONStorableString("instructions2", "\n Person plugin that randomizes morphs. Works with existing looks. Use Alter to add randomness to a model, use Realter if you don't like the last alteration and you want to undo it and do another one instead. ");
            UIDynamicTextField dtext = CreateTextField(jstring);
            dtext.UItext.supportRichText = true;
            dtext.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext.height = 350f;

			
			
			
            JSONStorableString jstring2 = new JSONStorableString("instructions1", "\n Mode = Head does random morphs only on the head, Body does morph changes on the whole body \n Reset = sets all morphs to 0 \n New Random \n Resets and starts a new random model \n Alter = Randomizes more the current model \n Undo = undoes last change, works only for 1 step, can't undo 2 moves back \n Re-alter undos the last move and does another alter \n\n Morph Chance = the % chance for each morph to change during an alteration \n Morph amount - the min and max values for the new random value of an altered morph");
            UIDynamicTextField dtext2 = CreateTextField(jstring2,true);
            dtext2.UItext.supportRichText = true;
            dtext2.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
            dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
            dtext2.height = 350f;
			
			
			
		    Utils.SetupSpacer(this, 70, false);
            Utils.SetupSpacer(this, 70, true);

            morphchangechance = new JSONStorableFloat("Morph Chance", 5f, 0f, 100f, false);
            CreateSlider(morphchangechance,false);
            RegisterFloat (morphchangechance);

            morphchangeamountmin = new JSONStorableFloat("Morph amount min", 0.05f, -1f, 2f, false);
            CreateSlider(morphchangeamountmin,false);
            RegisterFloat (morphchangeamountmin);

            morphchangeamountmax = new JSONStorableFloat("Morph amount max", 0.5f, -1f, 2f, false);
            CreateSlider(morphchangeamountmax,false);
            RegisterFloat (morphchangeamountmax);
            
            varMode = new JSONStorableStringChooser("Mode", modes, "Full Body", "Mode", CallbackChangeMode);
            RegisterStringChooser(varMode);
            UIDynamicPopup udpmode = CreatePopup(varMode, true);
            udpmode.labelWidth = 300f;
            

            varOperation = new JSONStorableStringChooser("OperationType", actions, "None", "Operation", OperationUpdate);
            RegisterStringChooser(varOperation);
            UIDynamicPopup udp = CreatePopup(varOperation, true);
            udp.labelWidth = 300f;
            
			
			
			
		}

		void Start() {
		}
		void Update() {
		
		}
		void FixedUpdate() {
			
		}
        void OnDestroy() {
		}


		//--------------------------------------//

        protected void CallbackChangeMode(string s){
            
        }

        protected void OperationUpdate(string s) {
            if(varOperation.val == "None") return;
            switch(varOperation.val){
                case "Reset": 
                    OperationReset();
                    break;
                case "New Random": 
                    OperationGenerateNewRandom();
                    break;
                case "Alter": 
                    OperationAlter();
                    break;
                case "Re-Alter": 
                    OperationRealter();
                    break;
                 case "Alter+": 
                    OperationAlterAdd();
                    break;
                case "Re-Alter+": 
                    OperationRealterAdd();
                    break;
                 case "Undo": 
                    OperationUndo();
                    break;
            }
            varOperation.val = "None";
        }


        string[] GetFemaleMorphs(){
            if(varMode.val == "Head") return SPQRUtils.GetAEMorphsHead();
            return SPQRUtils.GetAEMorphs();
        }

        string[] GetMaleMorphs(){
             var malemorphs = SPQRUtils.GetAEMorphsMale();
             return malemorphs;
        }

        void OperationUndo(){
            if(undo == null) return;
            var femalemorphs = GetFemaleMorphs();
            var malemorphs = GetMaleMorphs();
            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphs().ForEach((morph) =>{
                if(femalemorphs.Contains(morph.morphName)){
                    if(undo.ContainsKey(morph.morphName)){
                        morph.morphValue = undo[morph.morphName];
                    }
                }
                else if(malemorphs.Contains(morph.morphName)){
                    if(undo.ContainsKey(morph.morphName)){
                        morph.morphValue = undo[morph.morphName];
                    }
                }
            });

        }
        void OperationSaveUndo(){
            var femalemorphs = GetFemaleMorphs();
            var malemorphs = GetMaleMorphs();
            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            if(undo != null){
                undo.Clear();
            }
            undo = new Dictionary<string, float>();
            morphControl.GetMorphs().ForEach((morph) =>{
                if(femalemorphs.Contains(morph.morphName)){
                    if(!undo.ContainsKey(morph.morphName)){
                        undo.Add(morph.morphName, morph.morphValue);
                    }
                }
                else if(malemorphs.Contains(morph.morphName)){
                    if(!undo.ContainsKey(morph.morphName)){
                        undo.Add(morph.morphName, morph.morphValue);
                    }
                }
                
            });
            
        }
        void OperationReset(){
            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphs().ForEach((morph) =>{
                morph.morphValue = 0f;
            });
            OperationSaveUndo();
        }
        void OperationGenerateNewRandom(){
            OperationReset();
            OperationGenerateRandom();
        }
        
        void OperationGenerateRandom(){
            OperationSaveUndo();
            var femalemorphs = GetFemaleMorphs();
            var malemorphs = GetMaleMorphs();

            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphs().ForEach((morph) =>{
                if (morph.isInPackage) return;
                if(femalemorphs.Contains(morph.morphName)){
                    if((float)Random.Range(0f, 100f) < morphchangechance.val){
                        morph.morphValue= (float)Random.Range(morphchangeamountmin.val, morphchangeamountmax.val);
                    }
                } else if(malemorphs.Contains(morph.morphName)){
                    if((float)Random.Range(0f, 100f) < morphchangechance.val){
                        morph.morphValue= (float)Random.Range(morphchangeamountmin.val, morphchangeamountmax.val);
                    }
                }
                
            });

            
        }
        void OperationGenerateRandomAdd(){
            OperationSaveUndo();
            var femalemorphs = GetFemaleMorphs();
            var malemorphs = GetMaleMorphs();

            GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphs().ForEach((morph) =>{
                if (morph.isInPackage) return;
                if(femalemorphs.Contains(morph.morphName)){
                    if((float)Random.Range(0f, 100f) < morphchangechance.val){
                        morph.morphValue+= (float)Random.Range(morphchangeamountmin.val, morphchangeamountmax.val);
                    }
                }
                else if(malemorphs.Contains(morph.morphName)){
                    if((float)Random.Range(0f, 100f) < morphchangechance.val){
                        morph.morphValue+= (float)Random.Range(morphchangeamountmin.val, morphchangeamountmax.val);
                    }
                }
                
            });

            
        }
        void OperationAlter(){
            OperationGenerateRandom();
        }
         void OperationAlterAdd(){
            OperationGenerateRandomAdd();
        }
        void OperationRealter(){
            OperationUndo();
            OperationAlter();
        }
         void OperationRealterAdd(){
            OperationUndo();
            OperationAlterAdd();
        }


		void PopulateMorphs(){  
			morphsList1 = new Dictionary<string, float>(){};
			morphsList2 = new Dictionary<string, float>(){};
			morphsIds = new Dictionary<string, int>(){};
			
			for (var i = 0; i < countSliders; i++){
				var name = sliderName[i].val.Replace("\n", "").Replace("\r", "").Replace(",", "");
				sliderName[i].val = name;
				if(sliderName[i].val.Length < 0 ) continue;
				if(morphsList1.ContainsKey(sliderName[i].val) && morphsList2.ContainsKey(sliderName[i].val)) continue;
				morphsIds.Add(sliderName[i].val,i);
				morphsList1.Add(sliderName[i].val, sliderStart[i].val);
				morphsList2.Add(sliderName[i].val, sliderEnd[i].val);
			}
		}

		void UpdateSlider(JSONStorableFloat jf){
			PopulateMorphs();
			BlendCallback(jfloat);
		}
		void BlendCallback(JSONStorableFloat jf){
			GenerateDAZMorphsControlUI morphControl = returnMorphs();
            morphControl.GetMorphs().ForEach((morph) =>{
                if(morphsList1.ContainsKey(morph.uid)){
					morph.morphValue = Mathf.Lerp(morphsList1[morph.uid], morphsList2[morph.uid],jf.val);
					sliderValue[morphsIds[morph.uid]].val = morph.morphValue;
				}
			});
		}
		
		protected void UpdateVarValue(string s){ PopulateMorphs();}

		GenerateDAZMorphsControlUI returnMorphs() {
			JSONStorable geometry = containingAtom.GetStorableByID("geometry");
			DAZCharacterSelector character = geometry as DAZCharacterSelector;
			return character.morphsControlUI;
		}

		void WriteDebugList(){
			jstring3.val = "Preparing csv...";
			GenerateDAZMorphsControlUI morphControl = returnMorphs();
			string debugList =
				"uid,"+
				"resolvedDisplayName,"+
				"resolvedRegionName,"+
				"morphName,"+
				"displayName,"+
				"region,"+
				"group,"+
				"active,"+
				"isInPackage,"+
				"license"+
				"\r\n";
				
            morphControl.GetMorphs().ForEach((morph) =>{
				
				debugList+= 
				    morph.uid+","+
					morph.resolvedDisplayName+","+
					morph.resolvedRegionName+","+
					morph.morphName+","+
					morph.displayName+","+
					morph.region+","+
					morph.group+","+
					(morph.active ? "active" : "inactive" )+ ","+
					(morph.isInPackage ? "in package" : "no package" )+ ","+
					morph.packageLicense+","+
					"\r\n";
			});
			var csvPath = @"Saves\PluginData\MorphBlend\";
			if (!FileManagerSecure.DirectoryExists(csvPath)) FileManagerSecure.CreateDirectory(csvPath);
			FileManagerSecure.WriteAllText(csvPath+"morphs.csv",debugList);
			
			jstring3.val+= "\r\nDone! Saved in: "+csvPath+"morphs.csv";
			
		}
		
		private void CreateTitle(string text, int fontsize, bool right,int spacing){
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right){
                JSONStorableString title1 = new JSONStorableString("title"+(++titles), "\n<size="+fontsize+"><b>"+text+"</b></size>");
                UIDynamicTextField title1text = CreateTextField(title1, right);
                title1text.UItext.supportRichText = true;
                title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
                title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                title1text.height = 100f;
                title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }


	}
}