﻿using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;
using MacGruber;
using customevent;
using MVR.FileManagementSecure;
using Random = System.Random;
using Random2 = UnityEngine.Random;

namespace SPQR
{
    public class Grabbable : MVRScript
    {
		

        private bool gameIsVR;
		
		bool resetParent = false;
		
        GameObject playerHands;
        float collisionThreshold = 0.00f;

        protected JSONStorableString myString;
		public JSONStorableBool grababbleBool;

		protected FreeControllerV3 _fc;

        public override void Init()
        {
            Utils.OnInitUI(CreateUIElement);
            gameIsVR = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);
			
			_fc = containingAtom.GetStorableByID("control") as FreeControllerV3;


			bool showUI = false;
			
			grababbleBool = new JSONStorableBool("Grabbable", true);
			RegisterBool(grababbleBool);

            SimpleTriggerHandler.LoadAssets();
            UIUpdate();
            
        }

        private void UIUpdate()
        {
        }


        void Start()
        {	
			grababbleBool.val = true;
        }

        void Update()
        {
        }

        void FixedUpdate()
        {
            if(isBeingHeld()){
				resetParent = true;
			} else {
				if(resetParent){
					resetParent = false;
					_fc.SelectLinkToRigidbody(null);
				}
			}
        }
		
		void OnEnable(){
			grababbleBool.val = true;
		}

        void OnDisable()
        {
          grababbleBool.val = false;
        }

        void OnDestroy()
        {
			grababbleBool.val = false;
            Utils.OnDestroyUI();
            OnDisable();
        }

		bool isBeingHeld(){
			if(_fc.currentPositionState == FreeControllerV3.PositionState.Hold) return true;
			if(_fc.linkToRB != null){
				if(_fc.linkToRB.name == "SelectionHandles")  return true;
				if(_fc.linkToRB.name == "MouseGrab")  return true;
			}
			return false;
		}

        


    }



}
