﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class ProximityLight : MVRScript {

		JSONStorableFloat distanceTreshold;
		public Dictionary<string, JSONStorableBool> enableFeatures = new Dictionary<string, JSONStorableBool>();

		public override void Init() {

            if (!PluginAllowed())
            {
				SuperController.LogError("Plugin not allowed on this type of atom");
				return;
            }

			distanceTreshold = new JSONStorableFloat("Distance", 1f,  0.001f, 10f, false);
			RegisterFloat(distanceTreshold);
			CreateSlider(distanceTreshold);

			enableFeatures.Add("Log Distance", new JSONStorableBool("Log Distance", false));
			CreateToggle(enableFeatures["Log Distance"], true);



			InvokeRepeating("UpdateSecond_p67", 1f, 1f);
		}

	
		void Start() {
		
		}

	
		void Update() {
			if (!PluginAllowed()) return;

		}

	
		void FixedUpdate() {
		
		}
		
		void OnDestroy() {
			CancelInvoke();
        }

        void UpdateSecond_p67()
        {
			if (PluginDisabled()) return;
			UpdateLight();
        }
		bool PluginDisabled()
		{
			if (!enabledJSON.val) return true;
			return false;
        }
        bool PluginAllowed()
        {
			return true;
			if (containingAtom.type == "InvisibleLight") return true;
			return false;
        }

		void UpdateLight()
        {
            if (IsInProximity())
            {
				if(containingAtom.on == false) containingAtom.SetOn(true);
			} 
			else
            {
				if (containingAtom.on == true) containingAtom.SetOn(false);
			}
        }

		bool IsInProximity()
        {
			var distance = GetDistance();
			var close = (distance <= distanceTreshold.val);
			if (enableFeatures["Log Distance"].val)
            {
				SuperController.LogMessage( containingAtom.uid+": "+(close ? "IN PROXIMITY: " : "AWAY: ") +" distance: " + distance + " treshold:" + distanceTreshold.val);
            }
			if(close) return true;
			return false;
		}

		float GetDistance()
        {
			var light = containingAtom.mainController.transform.position;
			var person = SuperController.singleton.lookCamera.transform.position;
			return Mathf.Abs(Vector3.Distance(light, person));

		}
	}
}