﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OldVam : MVRScript {
		
		bool sceneLoaded = false;
		bool ok = false;
		public bool enabledLogs = false;

		OptimizeAnistropic oldvamOptimizeAnistropic;
		OptimizeClothes oldvamOptimizeClothes;
		OptimizeHair oldvamOptimizeHair;
		OptimizeLights oldvamOptimizeLights;
		OptimizePhysicsRate oldvamOptimizePhysicsRate;
		OptimizeSettingGraphics oldvamOptimizeSettingGraphics;
		OptimizeSettingLights oldvamOptimizeSettingLights;
		OptimizeSettingMirrors oldvamOptimizeSettingMirrors;
		OptimizeSettingPhysicshq oldvamOptimizeSettingPhysicshq;
		OptimizeSettingSoftphysics oldvamOptimizeSettingSoftphysics;
		OptimizeSettingVsync oldvamOptimizeSettingVsync;
		OptimizeSoftbodies oldvamOptimizeSoftbodies;



		public override void Init() {

			InvokeRepeating("UpdateSecond", 1f, 1f);
			InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;
		
			/*
			if (containingAtom.type != "SessionPluginManager")
			{
				SuperController.LogError("OldVam.cslist plugin must be added as a session plugin.");
				return;
			}
			*/

			ok = true;
			InitOptimizers();
		}

		void InitOptimizers()
        {
			oldvamOptimizeAnistropic = new OptimizeAnistropic(this);
			oldvamOptimizeClothes = new OptimizeClothes(this);
			oldvamOptimizeHair = new OptimizeHair(this);
			oldvamOptimizeLights = new OptimizeLights(this);
			oldvamOptimizePhysicsRate = new OptimizePhysicsRate(this);
			oldvamOptimizeSettingGraphics = new OptimizeSettingGraphics(this);
			oldvamOptimizeSettingLights = new OptimizeSettingLights(this);
			oldvamOptimizeSettingMirrors = new OptimizeSettingMirrors(this);
			oldvamOptimizeSettingPhysicshq = new OptimizeSettingPhysicshq(this);
			oldvamOptimizeSettingSoftphysics = new OptimizeSettingSoftphysics(this);
			oldvamOptimizeSettingVsync = new OptimizeSettingVsync(this);
			oldvamOptimizeSoftbodies = new OptimizeSoftbodies(this);
		}
	
		void Start() {
		
		}

	
		void Update() {
			if (IsDisabled()) return;
			oldvamOptimizeLights.Update();
		}

	
		void FixedUpdate() {
			if (IsDisabled()) return;
			oldvamOptimizeLights.Update();
		}
		void UpdateSecond()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;
			oldvamOptimizeAnistropic.UpdateOptimize();
			oldvamOptimizeClothes.UpdateOptimize();
			oldvamOptimizeHair.UpdateOptimize();
			oldvamOptimizeLights.UpdateOptimize();
			oldvamOptimizePhysicsRate.UpdateOptimize();
			oldvamOptimizeSettingGraphics.UpdateOptimize();
			oldvamOptimizeSettingLights.UpdateOptimize();
			oldvamOptimizeSettingMirrors.UpdateOptimize();
			oldvamOptimizeSettingPhysicshq.UpdateOptimize();
			oldvamOptimizeSettingSoftphysics.UpdateOptimize();
			oldvamOptimizeSettingVsync.UpdateOptimize();
			oldvamOptimizeSoftbodies.UpdateOptimize();
		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
		}
		bool IsDisabled()
        {
			if (!ok) return true;
			if (!enabledJSON.val)
			{
				return true;
			}
			
			return false;
		}

		public IEnumerator CoroutineCreateAtom_p67(string type, string atomid)
		{
			yield return SuperController.singleton.AddAtomByType(type, atomid);
		}



	}
}