﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeAnistropic : Optimize{
        public OptimizeAnistropic(OldVam x) : base(x)
        {
            checkDuration = 3.95f;
        }

        public override bool CheckChange()
        {
            if (UnityEngine.QualitySettings.anisotropicFiltering != AnisotropicFiltering.Disable) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UnityEngine.QualitySettings.anisotropicFiltering = AnisotropicFiltering.Disable;
            Log("Optimized anistropic filtering.");
        }


    }
}