﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSettingGraphics : Optimize{

        public OptimizeSettingGraphics(OldVam x) : base(x)
        {
            checkDuration = 3f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.smoothPasses != 1) return true;
            if (UserPreferences.singleton.msaaLevel != 0) return true;
            if (UserPreferences.singleton.shaderLOD != UserPreferences.ShaderLOD.Medium) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.smoothPasses = 1;
            UserPreferences.singleton.msaaLevel = 0;
            UserPreferences.singleton.shaderLOD = UserPreferences.ShaderLOD.Medium;
            Log("Optimized vam graphics settings");
        }




    }
}