﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSettingMirrors : Optimize{

        public OptimizeSettingMirrors(OldVam x) : base(x)
        {
            checkDuration = 3.3f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.mirrorReflections) return true;
            if (UserPreferences.singleton.realtimeReflectionProbes) return true;
            return false;
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.mirrorReflections = false;
            UserPreferences.singleton.realtimeReflectionProbes = false;
            Log("Optimized vam setting mirrors");
        }


    }
}