﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.Rendering;

namespace SPQR {
	public class OptimizeSettingVsync : Optimize{
        public OptimizeSettingVsync(OldVam x) : base(x)
        {
            checkDuration = 2.8f;
        }

        public override bool CheckChange()
        {
            if (UserPreferences.singleton.desktopVsync) return true;
            if (Application.targetFrameRate != 30) return true;
            return false;
            
        }

        public override void DoOptimize()
        {
            UserPreferences.singleton.desktopVsync = false;
            Application.targetFrameRate = 30;
            Log("Optimized vam setting vsync");
        }


    }
}