﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class OptimizeSoftbodies : Optimize{

        public OptimizeSoftbodies(OldVam x) : base(x)
        {
            checkDuration = 5.7f;
        }

        public override bool CheckChange()
        {
            return true;
        }

        public override void DoOptimize()
        {
            bool res = false;
            var allatoms_p67 = SuperController.singleton.GetAtoms();
            foreach (var a in allatoms_p67)
            {
                if (a.type != "Person") continue;

                //tongue
                var s1 = SPQRUtils.getAtomStorableBool_p67(a.uid, "TongueControl", "tongueCollision");
                if (s1.val)
                {
                    s1.val = false;
                    res = true;
                }
                //glutes
                var s2 = SPQRUtils.getAtomStorableBool_p67(a.uid, "LowerPhysicsMesh", "on");
                if (s2.val)
                {
                    s2.val = false;
                    res = true;
                }
                //breasts
                var s3 = SPQRUtils.getAtomStorableBool_p67(a.uid, "BreastPhysicsMesh", "on");
                if (s3.val)
                {
                    s3.val = false;
                    res = true;
                }
                //soft body physics
                var s4 = SPQRUtils.getAtomStorableBool_p67(a.uid, "SoftBodyPhysicsEnabler", "on");
                if (s4.val)
                {
                    s4.val = false;
                    res = true;
                }

            }
            if (res)
            {
                Log("Optimized softbodies");
            }
        }

     

     

    }
}