﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class Optimize{
		public OldVam X;
		public float lastCheck = 0f;
		public float checkDuration = 1f;

		public Optimize(OldVam x)
        {
			X = x;
        }
		
		public bool CheckTimeAllowed()
        {
			if(Time.time - lastCheck > checkDuration)
            {
				lastCheck = Time.time;
				return true;
            }
			return false;
        }

		bool CheckOptimize()
        {
			if (!CheckTimeAllowed()) return false; 
			return CheckChange();

        }


		public void UpdateOptimize()
		{
			if (!CheckOptimize()) return;
			DoOptimize();
		}

		public void Log(string s)
        {
			if (!X.enabledLogs) return;
			SuperController.LogMessage("oldvam: " + s);
        }

		/*-----------------------------------*/

		public virtual bool CheckChange() { return false; }
		public virtual void DoOptimize() { }
		

	}
}