﻿using System;
using UnityEngine;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;

namespace SPQR
{
    public class SPQRUI : MVRScript
    {
        // JSONStorableBool jbool;
        JSONStorableBool logo;
        JSONStorableBool logor;
        JSONStorableBool jstring;
        JSONStorableBool jstring2;

        FreeControllerV3.PositionState initialPositionState;
        bool initialPositionStateModified;
        bool initialPhysics;
        bool initialCollision;
        bool initialGravity;

		float moveDelta = 0.035f;
		float rotateDelta = 2f;



        public override void InitUI()
        {
            base.InitUI();

            if (UITransform == null) return;

            RectTransform leftRect = leftUIContent.GetComponent<RectTransform>();
            RectTransform rightRect = rightUIContent.GetComponent<RectTransform>();

            leftRect.anchorMax = new Vector2(0.66f, 1f);
            rightRect.anchorMin = new Vector2(0.66f, 1f);

        }


        public override void Init()
        {
            try
            {

                JSONStorableString logo = new JSONStorableString("logostring", "\n<size=40><b>AETERNUM TOOLS: PULL</b></size>");
                UIDynamicTextField logotext = CreateTextField(logo);
                logotext.UItext.supportRichText = true;
                logotext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logotext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                logotext.height = 100f;
                logotext.UItext.alignment = TextAnchor.UpperLeft;


                JSONStorableString logor = new JSONStorableString("logospace", "\n<size=30><b>v2</b></size>");
                UIDynamicTextField logortext = CreateTextField(logor, true);
                logortext.UItext.supportRichText = true;
                logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logortext.backgroundColor = new Color(0f, 0f, 0f, 0f);
                logortext.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
                logortext.height = 100f;
                logortext.UItext.alignment = TextAnchor.UpperRight;


                JSONStorableString jstring = new JSONStorableString("instructions1", "\nAdd the plugin as a Session plugin or Scene plugin to control the object that's selected in the scene. Add the plugin to an atom to always control just that object even if it's not selected. Adding it to multiple atoms will move all the objects that have the plugin.");
                UIDynamicTextField dtext = CreateTextField(jstring, true);
                dtext.UItext.supportRichText = true;
                dtext.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
                dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext.height = 450f;

                
                JSONStorableString jstring2 = new JSONStorableString("instructions2", "\n <b>CTRL-WASD</b> move selected target relative to the camera \n <b>CTRL-Q & CTRL-E</b> rotate side to side \n <b>CTRL-Z & CTRL-X</b> pull/push towards the camera \n <b>CTRL-R</b> reset position to floor \n <b>CTRL-SHIFT-R</b> reset all rotation \n <b>right thumbstick</b> up/down on VR to move the object towards the right hand.");
                UIDynamicTextField dtext2 = CreateTextField(jstring2);
                dtext2.UItext.supportRichText = true;
                dtext2.backgroundColor = new Color(0f, 0f, 0f, 0.9f);
                dtext2.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext2.height = 450f;
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void Start()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        void Update()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught x: " + e);
            }
        }

        void FixedUpdate()
        {
            try
            {
				if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.W))
                {
                    MoveUp();
                }
				if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.S))
                {
                    MoveDown();
                    
                }
				if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.A))
                {
                    MoveLeft();
                    
                }
				if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.D))
                {
                    MoveRight();
                    
                }
				
				if (Input.GetKey(KeyCode.LeftShift) && Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Q)) // Rotate Up
                {
                    RotateUp();
                    
                } else  if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Q)) // Rotate Left
                {
                    RotateLeft();
                    
                }


				if (Input.GetKey(KeyCode.LeftShift) && Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.E)) // Rotate Down
                {
                    RotateDown();
                    
                } else if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.E)) // Rotate Right
                {
                    RotateRight();
                    
                }


				if (Input.GetKey(KeyCode.LeftShift) && Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.R)) // Reset Rotation
                {
                    RotateReset();
                    
                } else if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.R)) // Reset Rotation
                {
                    PositionReset();
                    
                }


               
				
				
                if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.X)) // forward
                {
                    MoveSelectedAtomDesktop(false);
                    return;
                }
                if (Input.GetKey(KeyCode.LeftControl) && Input.GetKey(KeyCode.Z)) // backwards
                {
                    MoveSelectedAtomDesktop(true);
                    return;
                }
                
				
				if (SuperController.singleton.OVRCenterCamera != null)
                {
                    Vector2 val = OVRInput.Get(OVRInput.Axis2D.SecondaryThumbstick, OVRInput.GetActiveController());
                    if (val.y < -0.5f)
                    {
                        MoveSelectedAtomOVR(false, val.y);
                        return;
                    }
                    else if (val.y > 0.5f)
                    {
                        MoveSelectedAtomOVR(true, val.y);
                        return;
                    }

                }
                if (initialPositionStateModified)
                {
                    ResetPositionState();
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught x: " + e);
            }

        }
        void OnDestroy()
        {
        }


        //

        Atom GetTarget()
        {
            var atom = SuperController.singleton.GetSelectedAtom();
            if (containingAtom.type != "SessionPluginManager" && containingAtom.type != "CoreControl")
            {
                atom = containingAtom;
            }
            return atom;
        }

        void ResetPositionState()
        {
            initialPositionStateModified = false;
            var atom = GetTarget();
            if (atom == null) return;
            FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
            atomController.currentPositionState = initialPositionState;
            atomController.physicsEnabled = initialPhysics;
            atomController.collisionEnabled = initialCollision;
            atomController.useGravityOnRBWhenOff = initialGravity;
        }

        void SetPositionState(FreeControllerV3 atomController)
        {
            if (!initialPositionStateModified)
            {
                initialPositionStateModified = true;
                initialPhysics = atomController.physicsEnabled;
                initialCollision = atomController.collisionEnabled;
                initialGravity = atomController.useGravityOnRBWhenOff;
                initialPositionState = atomController.currentPositionState;
            }
            atomController.currentPositionState = FreeControllerV3.PositionState.Hold;
            atomController.physicsEnabled = false;
            atomController.collisionEnabled = false;
            atomController.useGravityOnRBWhenOff = false;
        }


		void Resetobject(FreeControllerV3 atomController){
			Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;	
			atomController.transform.localRotation = Quaternion.identity;
			atomController.transform.LookAt(cameraPosition);
			atomController.transform.Rotate(new Vector3(-atomController.transform.localEulerAngles.x,0f,-atomController.transform.localEulerAngles.z),Space.Self);

		}

		void MoveUp(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;

			Resetobject(atomController);
			atomController.transform.Rotate(new Vector3(0f,180f,0f),Space.Self);
			

			Vector3 atomDestination = new Vector3(0f, 0f, moveDelta);
			atomController.transform.Translate(atomDestination);



		}
		void MoveDown(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Resetobject(atomController);
			Vector3 atomDestination = new Vector3(0f, 0f, moveDelta);
			atomController.transform.Translate(atomDestination);
		}
		void MoveLeft(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Resetobject(atomController);
			atomController.transform.Rotate(new Vector3(0f,90f,0f),Space.Self);
			Vector3 atomDestination = new Vector3(0f, 0f,moveDelta);
			atomController.transform.Translate(atomDestination);
		}
		void MoveRight(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Resetobject(atomController);
			atomController.transform.Rotate(new Vector3(0f,270f,0f),Space.Self);
			Vector3 atomDestination = new Vector3(0f, 0f, moveDelta);
			atomController.transform.Translate(atomDestination);
		}
			
		void PositionReset(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			Vector3 atomDestination = new Vector3(atomController.transform.position.x, 0f, atomController.transform.position.z);
			atomController.transform.position = atomDestination;
		}
		void RotateReset(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.localRotation = Quaternion.identity;
		}

		void RotateLeft(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.Rotate(new Vector3(0f,-rotateDelta,0f),Space.Self);
		}
		void RotateRight(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.Rotate(new Vector3(0f,rotateDelta,0f),Space.Self);
		}
		void RotateUp(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.Rotate(new Vector3(-rotateDelta,0f,0f),Space.Self);
		}
		void RotateDown(){
			var atom = GetTarget();
            if (atom == null) return;
			FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
			atomController.transform.Rotate(new Vector3(rotateDelta,0f,0f),Space.Self);
		}

        void MoveSelectedAtomDesktop(bool pull)
        {
            var atom = GetTarget();
            if (atom == null) return;

            Vector3 cameraPosition = SuperController.singleton.MonitorCenterCamera.transform.position;
            FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
            Vector3 atomPosition = atomController.transform.position;
            Vector3 atomDestination = new Vector3(cameraPosition.x, atomPosition.y, cameraPosition.z);

            if (atomPosition == atomDestination) return;
            float distance = Vector3.Distance(atomPosition, atomDestination);
            if (distance < 2f && pull) return;

            float delta = pull ? 0.1f : -0.1f;
            Vector3 newPosition = Vector3.MoveTowards(atomPosition, atomDestination, delta);
            SetPositionState(atomController);
            atomController.transform.position = newPosition;



        }

        void MoveSelectedAtomOVR(bool pull, float delta)
        {
            var atom = GetTarget();
            if (atom == null) return;
            bool found = false;
            Vector3 rhPosition = new Vector3(0f, 0f, 0f);
            var ovr = SuperController.singleton.OVRRig.transform.GetChild(0).transform;
            for (var i = 0; i < ovr.childCount; i++)
            {
                if (ovr.GetChild(i).name == "RightHandAnchor")
                {
                    found = true;
                    rhPosition = ovr.GetChild(i).transform.position;
                }

            }
            if (!found) return;


            // Vector3 cameraPosition = SuperController.singleton.OVRCenterCamera.transform.position;
            Vector3 cameraPosition = rhPosition;
            FreeControllerV3 atomController = atom.GetStorableByID("control") as FreeControllerV3;
            Vector3 atomPosition = atomController.transform.position;
            delta = delta * -0.15f;
            Vector3 atomDestination = new Vector3(cameraPosition.x, cameraPosition.y, cameraPosition.z);
            if (atomPosition == atomDestination) return;
            Vector3 newPosition = Vector3.MoveTowards(atomPosition, atomDestination, delta);
            atomController.transform.position = newPosition;


        }
    }
}