﻿using System;
using System.Linq;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace SPQR {
	public class TextureAnimator : MVRScript {
		
		bool sceneLoaded = false;

		JSONStorableBool valIsX;
        JSONStorableFloat valSpeed;
		
		JSONStorable jsonStorableMaterials;
		JSONStorableFloat jsonStorableOffsetX;
        JSONStorableFloat jsonStorableOffsetY;

        Dictionary<string, JSONStorableString> titles = new Dictionary<string, JSONStorableString>();

        float currentVal;

		float originalX, originalY;
        public override void Init() {

			InvokeRepeating("UpdateSecond", 1f, 1f);
			InvokeRepeating("UpdateConstant", 1f, 1f / 30f);
			InvokeRepeating("UpdateConstant5", 1f, 1f / 5f);
			SuperController.singleton.onSceneLoadedHandlers += OnSceneLoaded;



            CreateTitle_p67("titlepluginname", "TextureAnimator", 40, false);
            CreateTitle_p67("titlepluginname2", "patreon.com/SPQR_AETERNUM", 20, true);



            valSpeed = new JSONStorableFloat("Speed", -1f, -10f, 10f, false,true);
            RegisterFloat(valSpeed);
            CreateSlider(valSpeed);

			valIsX = new JSONStorableBool("Is X axis", false, OnAxisChange);
			RegisterBool(valIsX);
			CreateToggle(valIsX, true);

            jsonStorableMaterials = containingAtom.GetStorableByID("materials");
            if (jsonStorableMaterials == null) return;
            jsonStorableOffsetX = jsonStorableMaterials.GetFloatJSONParam("customTexture1OffsetX");
            jsonStorableOffsetY = jsonStorableMaterials.GetFloatJSONParam("customTexture1OffsetY");
            if (jsonStorableOffsetX == null) return;

			originalX = jsonStorableOffsetX.val;
            originalY = jsonStorableOffsetY.val;

        }

	
		void Start() {
		
		}

	
		void Update() {
			if (SuperController.singleton.freezeAnimation) return;
            currentVal = (valSpeed.val/10f * Time.time % 2) - 1f;

			if (valIsX.val) jsonStorableOffsetX.val = currentVal;
			else jsonStorableOffsetY.val = currentVal;

        }

	
		void FixedUpdate() {
		
		}
		void UpdateSecond()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant()
		{
			if (IsDisabled()) return;

		}
		void UpdateConstant5()
		{
			if (IsDisabled()) return;

		}
		void OnDestroy()
		{
			CancelInvoke();
			SuperController.singleton.onSceneLoadedHandlers -= OnSceneLoaded;
		}

		void OnSceneLoaded()
		{
			sceneLoaded = true;
		}
		bool IsDisabled()
        {
			if (!enabledJSON.val)
			{
				return true;
			}
			return false;
		}

		void OnAxisChange(bool isX)
		{
			if (isX)
			{
              
                jsonStorableOffsetY.val = originalY;
            } else
			{
                jsonStorableOffsetX.val = originalX;
            }
		}
        void CreateTitle_p67(string id, string text, int fontsize, bool right, int spacing)
        {
            CreateTitle_p67(id, text, fontsize, right);
            CreateSpacer_p67(this, spacing, right);
        }


        UIDynamic CreateSpacer_p67(MVRScript X, float height, bool rightSide)
        {
            UIDynamic spacer = X.CreateSpacer(rightSide);
            spacer.height = height;
            return spacer;
        }

        void CreateTitle_p67(string id, string text, int fontsize, bool right)
        {
            if (!titles.ContainsKey(id))
                titles.Add(id, new JSONStorableString("title " + id, "\n<size=" + fontsize + "><b>" + text + "</b></size>"));
            UIDynamicTextField title1text = CreateTextField(titles[id], right);
            title1text.UItext.supportRichText = true;
            title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
            title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            title1text.height = 100f;
            title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

    }
}